global loader				; making entry point visible to linker
 
extern kernel_main
 
; setting up the Multiboot header - see GRUB docs for details
MODULEALIGN equ  1<<0			; align loaded modules on page boundaries
MEMINFO     equ  1<<1			; provide memory map
FLAGS	    equ  MODULEALIGN | MEMINFO	; this is the Multiboot 'flag' field
MAGIC	    equ    0x1BADB002		; 'magic number' lets bootloader find the header
CHECKSUM    equ -(MAGIC + FLAGS)	; checksum required
 
section .text
 
align 4
    dd MAGIC
    dd FLAGS
    dd CHECKSUM
 
; reserve initial kernel stack space
STACKSIZE equ 0x4000 ; 16kb.

loader:
    mov  esp, stack + STACKSIZE 	; set up the stack
   ; push eax                            ; Multiboot magic number
   ; push ebx; Multiboot info structure
     mov ax,0
     mov ax, 0x1003
     mov bl,0x00
     ;int 0x10

     call kernel_main			       ; call kernel proper
;    cli

;disable_blink:
;     mov ax, 0x1003
;     mov bl,0x00
;     int 10h
;     ret


.hang:
    call kernel_main				     ; halt machine should kernel return
    jmp  .hang
 
section .bss
 
align 4
stack:
    resb STACKSIZE			; reserve 16k stack on a doubleword boundary